Last Comment Bug 52746 - (dynamicfonts) Mozilla does not support dynamic fonts
(dynamicfonts)
: Mozilla does not support dynamic fonts
Status: RESOLVED FIXED
relnote-devel
: arch, css2, helpwanted, testcase
Product: Core
Classification: Components
Component: Layout: Text (show other bugs)
: Trunk
: All All
: P3 normal with 100 votes (vote)
: Future
Assigned To: Nobody; OK to take it and work on it
:
Mentors:
http://www.malayalamanorama.com, http...
: 62831 65904 67459 75204 76345 78084 106766 174324 174540 189569 196907 202267 206763 208603 209833 213213 218661 222877 226810 261314 272200 274246 274287 275295 282991 284735 288575 288577 289879 291928 297864 302365 304984 312981 315628 315629 317537 330250 344645 360910 361622 370039 396195 476832 (view as bug list)
Depends on: 70132
Blocks: 164421 advocacybugs 407316
  Show dependency treegraph
 
Reported: 2000-09-14 20:27 PDT by Shaji
Modified: 2011-05-29 08:33 PDT (History)
108 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description Shaji 2000-09-14 20:27:49 PDT
Mozilla does not seem to support dynamic fonts like Netscape 4.x. Is it not
going to be supported ever? Most of Indian language websites uses dynamic fonts,
and if mozilla does not support it it will be ignored by everyone. See how
different the above website appear on mozilla and netscape 4.x(or IE)
Comment 1 R.K.Aa. 2000-09-14 20:43:58 PDT
I don't think it intends to either.
But that page freeze linux with following output

Error loading URL http://www.malayalamanorama.com/: 804b0002
Gdk-ERROR **: BadValue (integer parameter out of range for operation)
  serial 533764 error_code 2 request_code 45 minor_code 0
Gdk-ERROR **: BadFont (invalid Font parameter)
  serial 533765 error_code 7 request_code 47 minor_code 0


Even if it doesn't angle dynamic fonts, it shouldn't hang like that.
Had to kill it - 97/99% CPU as usual.
Comment 2 Doron Rosenberg (IBM) 2000-09-15 13:51:30 PDT
http://validator.w3.org/check?uri=http%3A%2F%2Fwww.malayalamanorama.com%2F -
shows errors in the dynamic fonts code.

Since this works in 4.7x, sending to DOM 0. However, I understand that we don't
support this now.
Comment 3 Johnny Stenback (:jst, jst@mozilla.com) 2000-09-29 02:01:08 PDT
This is not a DOM problem, Chris, any idea who this should go to?
Comment 4 Chris Waterson 2000-09-29 10:14:08 PDT
erik, is this you?
Comment 5 Erik van der Poel 2000-09-29 10:23:01 PDT
We have no plans for dynamic fonts in Netscape 6. I don't know of any
mozilla.org activity in this area either. Accepting bug for now, with milestone
Future.
Comment 6 Prashant Desale 2000-11-01 16:25:18 PST
adding keyword relnoteRTM. Dynamic fonts are widely used.
Comment 7 R.K.Aa. 2001-02-02 11:05:58 PST
*** Bug 67459 has been marked as a duplicate of this bug. ***
Comment 8 timeless 2001-02-04 02:45:12 PST
Toolkit?  helpwanted !!
Comment 9 John Morrison 2001-02-04 17:07:04 PST
If ever implemented (unlikely), it would be done in core layout
-> back to erik, layout, still Future
Comment 10 Brian 'netdragon' Bober 2001-03-14 01:19:22 PST
Mozilla should support it in exactly the same way (if possible) that IE does so 
there is some kind of fonts standard on the internet.
Comment 11 Martin Horwath 2001-04-09 05:48:13 PDT
*** Bug 75204 has been marked as a duplicate of this bug. ***
Comment 12 Gyula Zsigri 2001-04-09 09:08:25 PDT
Mozilla is like Internet Explorer: neither supports dynamic fonts.
Would not it be a better idea to make it like Netscape Communicator?
Comment 13 Alexey Chernyak 2001-04-17 11:48:13 PDT
*** Bug 76345 has been marked as a duplicate of this bug. ***
Comment 14 Alexey Chernyak 2001-04-17 12:24:28 PDT
CCing Frank Tang who I believe is working on this.

related bugs, I'm not sure which should be marked as duplicates:
bug 41250
bug 65904
Comment 15 timeless 2001-04-29 00:39:16 PDT
*** Bug 78084 has been marked as a duplicate of this bug. ***
Comment 16 Frank Tang 2001-05-07 23:43:33 PDT
erik resign. reassign all his bug to ftang for now.
Comment 17 Frank Tang 2001-05-08 00:18:34 PDT
mark all future new as assigned after move from erik to ftang
Comment 18 Henri Sivonen (:hsivonen) 2001-06-29 09:09:26 PDT
*** Bug 62831 has been marked as a duplicate of this bug. ***
Comment 19 Boris Zbarsky [:bz] 2001-07-03 14:28:04 PDT
*** Bug 65904 has been marked as a duplicate of this bug. ***
Comment 20 Boris Zbarsky [:bz] 2001-10-25 17:55:31 PDT
*** Bug 106766 has been marked as a duplicate of this bug. ***
Comment 21 Johannes Lindqvist 2001-11-20 17:18:56 PST
If this is going to be fixed, it should of course be done in accordance with the
CSS2 specification, and not "like in 4.7". 

It worries me if you aren'tplanning to support CSS2 fully.
Comment 22 srikanth Koneru 2001-11-21 23:27:23 PST
This bug should be fixed. Dynamic fonts should be supproted. IE does support
dynamic fonts(proof: Try www.eenadu.net on IE and mozilla and see the diference
IE displays correctly). So don't expect that mozilla not supporting dynamic
fonts will discourage anybody from not using dynamic fonts. 

This bug limits the usage of mozilla to English speaking countries. Also 4.7x
supports dynamic fonts so we might loose some of those actually using netscape4.7x
Comment 23 Vassilii Khachaturov 2001-12-01 19:19:55 PST
(See also bug # 59611)
I have called BitStream to go open source with the TrueDoc PFR technology
for the benefit of the Mozilla project, and they indicated they're ready
to do so. Please see my article on this topic at

http://www.tarunz.org/~vassilii/BitStream.html
Comment 24 Vijay Kumar 2002-03-10 21:09:19 PST
i visited a site eenadu.net, using the build 2002030803, which is using dynamic
fonts, but the page is not displayed properly. While this page is being shown
properly in IE. 
Comment 25 ratman 2002-06-09 12:39:05 PDT
using moz1.0 on winme.

still no dynamic fonts!  to put this straight, dynamic fonts *are* part of css2,
and *are* supported by both ie (since at least version 4) and netscape 4.x.

what is the issue here?  if it is a proprietary one, then this bug should be
shifted to a different component.

we're not only leaving a lot of international users out in the lurch with this,
but it doesn't look too good when 4+ year-old browsers work better than the
"official release" version.

strongly suggest increasing priority or *something* to put this back on the
radar.  keyword 4xp, too, just to rub our noses in it.  ;)
Comment 26 Andrew Hagen 2002-06-09 14:06:26 PDT
What's the status of this bug? Is the Bitstream option viable?
Comment 27 Jeffrey Chan 2002-09-13 13:05:49 PDT
What's the status? Is Bitstream still interested in open-sourcing TrueDoc? CSS2
supports Truedoc *and* EOT, it's a rather important feature for standard
compliance sake.

NS4.x used to be able to view EOT also by means of the generic Active-X bridging
plugin as far as I can remember.
Comment 28 Sören 'Chucker' Kuklau (gone) 2002-10-08 09:45:03 PDT
"to put this straight, dynamic fonts *are* part of css2,"

Wait a minute. Last I checked, there *was* the ability to include a font file in
CSS2, but there was *no* clearly defined *format* for that.

Assignee: are you still working on this?
Comment 29 Neil Cronin 2002-10-21 14:00:37 PDT
*** Bug 174540 has been marked as a duplicate of this bug. ***
Comment 30 Walter Baranger 2002-11-01 16:36:39 PST
This bug has been tossed around for more than two years. Meanwhile, my company 
has moved on and last month we decided to use Internet Explorer because it 
supports dynamic fonts (on the PC platform, at least).

Yes, CSS2 supports dynamic fonts. There's even a syntax, thought it takes some 
digging through the documentation to assemble all of the proper syntax.

And Bitstream says they'll put the technology into the public domain, if asked 
to do so.

So why doesn't this bug ever get resolved?
Comment 31 Andrew Hagen 2002-11-01 18:03:35 PST
The barrier is that no developer has done the work. That means a lack of money,
interest, or time. 

If someone steps up to the plate and does the work, and the code is good, I'm
positive it will be not only be checked in, but also the developer and his
sponsor will have the gratitude of the entire Mozilla community. 

You, or your company, or anyone is welcome to hire a developer to write that code.
Comment 32 Andrew Schultz 2002-12-09 09:39:25 PST
==> Fonts/text
Comment 33 Boris Zbarsky [:bz] 2003-02-15 11:11:36 PST
*** Bug 174324 has been marked as a duplicate of this bug. ***
Comment 34 Gilles Durys 2003-03-11 14:33:47 PST
*** Bug 196907 has been marked as a duplicate of this bug. ***
Comment 35 Samir Gehani 2003-03-13 12:09:00 PST
i18n triage team: nsbeta1-
Comment 36 Simon Montagu :smontagu 2003-03-17 10:35:50 PST
*** Bug 189569 has been marked as a duplicate of this bug. ***
Comment 37 Maxim Massalitin 2003-03-20 06:57:17 PST
It's not worth to mention "lack of money, interest, or time", etc. Many
languages have to use embedding fonts. MS WEFT resolves this problem but in
their wicked manner. According to W3C/CSS2 any CSS2-browser should use
@font-face rule to specify font description
(http://www.w3.org/TR/REC-CSS2/fonts.html#font-descriptions). This rule
specifies to use embedding fonts .pfr, .eot, .pfb, .pfa, .ttf.

It's strange why mozilla community hadn't time or interest to resolve that
problem for two years
Comment 38 Kim Scarborough 2003-03-20 08:45:28 PST
Sorry to spam the bug but my annoyance threshhold was finally crossed. I too am
anxious for Mozilla to support dynamic fonts, but the purpose of dynamic fonts
is *not* to support international charsets! If you need dynamic fonts for that,
you're coding your page (or configuring your server) wrong. Mozilla, unlike
Netscape 4 and below (but like IE), is very good about correctly picking an
appropriate font for your language, *provided you have specified the charset
correctly*. You will note that *neither* of the sites listed in the URL field of
this bug do so. 

To see an international site that renders correctly, go to the site I maintain,
<http://www.bignews.org/>. You'll note that the Chinese characters display fine,
even in the plaintext files that are linked from the main page. Go to
<http://www.w3.org/International/O-HTTP-charset> and
<http://www.htmlhelp.com/tools/validator/charset.html> to see how to specify
character sets. This bug is a *design* issue, not an internationalization one. 

Since I'm barking anyway, I'd like to clear up a couple things. IE does support
dynamic fonts, and it does it correctly; it's completely in keeping with the
CSS2 spec. Yes, it only supports its proprietary .eot pseudo-font files, but
that doesn't make it any more non-compliant than if it didn't support .png
files. Netscape 4 did support dynamic fonts in some versions, but it did it in a
non-compliant way; there was no way you could include them without writing
invalid HTML. There's nothing wrong with the Bitstream format, though, and no
reason why Bitstream .pfr files couldn't be supported through the proper CSS2
way. For that matter, there's no reason .ttf files couldn't be supported that
way. Yes, there are copyright issues, but I don't see why that's the browser's
problem. There are plenty of public domain TTF files; why can't I embed them in
my page? Mozilla still loads my jpegs, even though I might have stolen them.

comment 28 has been bugging me, too. Why would the CSS spec specify the file
format for embedded fonts? That's not the purpose of CSS, and it doesn't specify
the file format for images, sounds, or anything else.

Okay, that's it, except that people should stop complaining about this not being
fixed. The bug's here, people are voting for it, there are a lot of dupes, it'll
get done eventually, and whining won't speed anything up. If you really want to
get it fixed and can't code, take up a collection to hire a coder like they did
in bug 17048 (which is now close to being fixed).
Comment 39 Damian Yerrick 2003-03-20 19:35:11 PST
"provided you have specified the charset correctly"

What is the correct charset specification for Tengwar, a script that
has not yet been accepted into Unicode?

And how much would you estimate that it would cost to fix this bug?
Comment 40 Walter Baranger 2003-03-20 20:13:14 PST
I'll say it again: Why should my company spend a penny to fix this bug when we 
can simply switch to IE? In fact, that's what we did.

I could argue about investing time and money to help Mozilla fix it, but the 
answer is obvious: My company uses the best tools for the job, and Mozilla 
without dynamic fonts is not the best tool. IE is free, so we switched.

Philisophical arguments hold little sway against financial arguments. Netscape 
must finance this fix or they will continue losing clients to IE. It's that 
simple.
Comment 41 Andrew Hagen 2003-03-22 16:00:07 PST
I think font-face support is bug 70132.
Comment 42 Boris Zbarsky [:bz] 2003-04-15 13:49:34 PDT
Walter, if you feel that Netscape should finance this fix, I would suggest
contacting Netscape and letting them know that... Mentioning it in a bug in a
non-Netscape bug database is not likely to get the attention of the
purse-string-keepers at Netscape (at best, it will be seen by a Netscape
developer who has no power to make such decisions anyway).  Contacting Netscape
management directly, one company to another, would be much more effective...
Comment 43 Boris Zbarsky [:bz] 2003-04-16 08:51:29 PDT
*** Bug 202267 has been marked as a duplicate of this bug. ***
Comment 44 Simon Montagu :smontagu 2003-05-22 13:54:45 PDT
*** Bug 206763 has been marked as a duplicate of this bug. ***
Comment 45 guanxi 2003-05-23 06:10:05 PDT
re: comment #40

Walter,

RE: CHOICE OF BROWSER
Certainly, depending on the situation, Mozilla, IE or both are appropriate tools.

In your situation, Mozilla apparently has a disadvantage:  It doesn't support
dynamic fonts.  

It also has several advantages:  For example, in your situation (if you work for
the NY Times as your e-mail address implies), I would think privacy and security
of data would be paramount; certainly, software that opens security holes on
reporters computers would be a serious problem.  IE has a poor reputation for
security and privacy.

You say IE is free, but that's only to buy.  Consider also the cost to deploy,
support, and integrate with other systems.  Those costs depend on your
situation, also.  Mozilla's greater stability and security reduces support
costs; its cross-platform nature reduces some integration costs, but of course
IE is compatible with more proprietary back end systems.


RE: OPEN SOURCE DEVELPOMENT MODEL
You ask, "Why should my company spend a penny to fix this bug"?

The answer to your question seems obvious:

Why should the NY Times (again, if that's who you represent) give back to the
community?   A community that promotes the ability of people to freely, as in
beer and speech, communicate?  Does the NY Times really want all Internet
communication to flow through one, commercial, gatekeeper?


I very much like the newspaper, by the way.
Comment 46 guanxi 2003-05-23 06:20:29 PDT
Walter - 

I should add, though I probably shouldn't belabor this off-topic point:

Some day, who knows when, most news will be read via the Internet.  On that day,
without Moz or some alternative browser, readers will have to go through
Microsoft to get to the NY Times.

Are they a trustworthy partner?  They have quite an agressive track record. 
What happens when IE comes with it's own search engine and home page (e.g. MSN),
and responding to criticism in the Times, removes nytimes.com from their search
engine and other links.

Readership that day will drop to AOL and the dozen or so Opera users. 
Alternative browsers seem to me to be essential for your business.

Comment 47 Steve Koppelman 2003-05-24 09:13:37 PDT
I'm curious as to why the New York Times Company needs dynamic font support. 
Putting the page's language and encoding in the header will render a page 
automatically and properly in that language on both IE and Mozilla as long as 
the device has a font for that character set. Specifying the encoding and 
charset in the document's markup will do the same, and let you render 
multilingual pages just fine, too.

The second (and perhaps original) purpose of dynamic fonts was to get pretty-
looking, smooth, antialiased font rendering on pages. This is now done at the 
operating system level on WinXP, MacOS X and most Unixes.

The only solid, legit uses for dynamic fonts going forward are still good 
reasons to have it: (1) making it possible to read any language on any PC--even 
a securely locked-down one, so an Armenian wor Gujarati traveler can walk into 
a cybercafe in South Korea or Brazil and read her or his hometown websites, and 
(2) so the NY Times, for instance, can display its masthead in its trademark 
typeface without using a graphic.

Yes, this should be implemented--but I'm still curious as to the business 
reasons the NY Times Company finds it important to be able to render languages 
not read by the owners of a given PC and that still can't be typed on that PC.
Comment 48 Simon Montagu :smontagu 2003-06-18 13:57:09 PDT
*** Bug 209833 has been marked as a duplicate of this bug. ***
Comment 49 Kurtis McCathern 2003-07-02 15:13:52 PDT
Um, I just tried this on a page that has CSS2 for both .eot and .ttf (though I
didn't think anybody supported it) and it rendered correctly on Mozilla 1.4 on
OS X!!??  Is the Mac font handling different than Mozilla for PC and Unix?  Why
can they do it correctly and Windows can't?
Comment 50 Bill Mason 2003-09-08 11:56:08 PDT
*** Bug 218661 has been marked as a duplicate of this bug. ***
Comment 51 Christopher Aillon (sabbatical, not receiving bugmail) 2003-10-19 13:26:49 PDT
*** Bug 222877 has been marked as a duplicate of this bug. ***
Comment 52 osavill 2003-10-21 13:39:50 PDT
I came to this bug because a client of mine wanted his page to render using a 
font that is non-standard to PCs. It's not a foreign language font or anything 
weird. It just happens to be non standard on PCs, and probably Macs too. 
 
There are various things that IE does, some in the standards most not, which 
clients are finding `cool'. The knowledge about them is seeping out and I am 
finding that clients are wanting these features. Mozilla is the ONLY 
alternative to IE both on the Windows platform and others. I realise that 
standards come first but, given Mozilla increasing maturity, isn't it time to 
start considering cool and fun features ? 
Comment 53 John Coonrod 2004-04-07 11:48:23 PDT
If Mozilla is to support css2 and be of service to the 2 billion people of Asia,
it needs to support dynamic fonts. I strongly recommend it be treated as a
serious bug and that 1.8 not get released without it.
Comment 54 Kim Scarborough 2004-04-07 11:53:25 PDT
Sigh. Please see my previous comment 38. Dynamic fonts are *not* necessary for
internationalization. Properly-configured Asian-language sites render fine in
Mozilla, see <http://www.yahoo.co.jp/> and <http://www.bignews.org/20040401.txt>
for Japanese and Chinese examples, respectively.

This is a design feature request, not an internationalization bug.
Comment 55 John Coonrod 2004-04-07 12:01:53 PDT
If Mozilla is to support css2 and be of service to the 2 billion people of Asia,
it needs to support dynamic fonts. I strongly recommend it be treated as a
serious bug and that 1.8 not get released without it.
Comment 56 John Coonrod 2004-04-07 12:09:26 PDT
Kim, I did see your comment, but your comment is just plain wrong for South
Asia.  I've seen no such thing as an agreed upon Bengali font that people can
install and browse the web with. Find me one Bengali site that doesn't use
either dynamic fonts or pdf files and I might believe you. There are 220 million
Bengali's on our planet - most of them have lousy bandwidth, and are so really
tired of downloading pdfs. So what they are using is IE or Netscape 4.7 with
dynamic fonts.
Comment 57 Kim Scarborough 2004-04-07 12:22:09 PDT
> Find me one Bengali site that doesn't use either dynamic fonts or pdf files

Sure, here's one:

<http://www.stat.wisc.edu/~deepayan/Bengali/WebPage/Archive/Madhusudan/Chaturdashpadi/archive.bn.html>
Comment 58 Kim Scarborough 2004-04-07 12:49:41 PDT
> I've seen no such thing as an agreed upon Bengali font that people can install
and browse the web with.

Here's some free downloads of Bengali UTF-compliant fonts that people can
install and browse the web with:

<http://www.nongnu.org/freebangfont/>

Also, Arial Unicode, which comes with Microsoft Office, has Bengali support.
Microsoft used to offer it as a free download, but I can't find it anymore.

Anyway, sorry to waste everyone else's time with this but supporting
international character sets via font embedding is an awful practice that needs
to be stopped.

Comment 59 John Coonrod 2004-04-07 13:14:05 PDT
OK, I stand corrected! I'll now see if I can figure out how to convert our old
Bengali documents to Unicode, and we'll put them onto the web!
Comment 60 Brian 'netdragon' Bober 2004-04-07 16:25:01 PDT
If this needs to be fixed to fully support CSS2, I agree with giving this a
higher priority.

The browser versions are churning out too fast in my opinion, giving not enough
time for feature additions and bringing us too close to version 2.0. Wouldn't
full support for CSS2 be something amiable for 2.0?

This bug also has 49 votes. Is Frank Tang still active or should we give this to
nobody@mozilla.org?

Comment 61 guanxi 2004-04-08 07:22:00 PDT
(In reply to comment #58)

Kim - If very few website use your solution (which is my impression -- correct
me if I'm wrong), no matter how technically superior it is, aren't we selling
Betamax?

Users want to use websites; if Moz doesn't work with many websites, and IE works
using an inferior technology, guess which browser the users will choose.
Comment 62 Damian Yerrick 2004-04-11 12:09:47 PDT
Sure, it works with Bengali, because the marketing department of Microsoft
Corporation has chosen to support Bengali in the company's popular operating
system. But then how does one write a web page in a script that the Microsoft
Windows operating system does not support?  For instance, how would I write and
publish a web page written in Tengwar script or any other script that is too
rare to make it into the Unicode standard?  Would I have to use one image per
letter or one image per line of text or something?
Comment 63 Walter Baranger 2004-04-11 12:38:12 PDT
I've long since given up on getting dynamic fonts in Mozilla, and I moved 
my company to IE6 (another free browser). But for those of you who think 
dynamic fonts are some sort of neanderthal technology that should be 
stomped out -- or just something useless -- here were my reasons (some 
of which affect different aspects of my company's business):

1) I need the ability to display many fonts, including non-Unicode fonts. 
Using thousands of gif files is not practical for many reasons, and it does 
the end user no good either.

2) I'm not happy displaying the same generic fonts as everyone else. I 
need something the makes my web site stand out, and custom fonts do 
this. The only economical way to distribute custom fonts is via the 
dynamic font model of CSS. This way I bear the sole cost of the font 
licensing.

3) I want something that is CSS2 compatible (no cracks about Microsoft 
vs. the world's standards bodies, please); any browser that has written off 
dynamic fonts has also written off CSS2 compatibility.

4) I want to use CSS on a variety of output devices; in some cases, I want 
to swap out a dynamic screen font in favor of an embedded generic font 
when the user prints out the page. Try THAT with teenie-weenie GIFs!

5) Fonts are not just technical renderings of characters; they are works of 
art that should be afforded no less respect than, say, my company logo. 
To ask third-world users -- many of whom cannot affort to buy font libraries 
-- to tolerate a simple generic Unicode font for all of their web needs is 
just culturally insensitive and fails to take into account the complex 
linguistic needs of many "foreign" languages.

I sit on several XML standards committees, and I regularly vote on matters 
that affect users of non Latin-1 character sets. If I've learned anything, it's 
that they need all  the flexibility and creative tools that can be offered. 
Killing dynamic fonts is a step backwards, IMHO.
Comment 64 Hixie (not reading bugmail) 2004-04-11 12:48:43 PDT
Glyph sets that aren't in the Unicode standard should be proposed to Unicode for
inclusion, and in the meantime, should use the Private Use Area. Note, though,
that this has nothing to do with this bug.

This bug is about @font-face and dynamic font download, a feature that will be
supported in Mozilla as soon as someone implements it (or pays someone to
implement it). The people who currently work on Mozilla do not consider this bug
a priority. This is unlikely to change, regardless of how much people say that
this is a critical feature in this bug.
Comment 65 guanxi 2004-04-11 14:09:00 PDT
(In reply to comment #64)
> The people who currently work on Mozilla do not consider this bug
> a priority. This is unlikely to change, regardless of how much people say that
> this is a critical feature in this bug.

It would be basic consideration if they'd make an argument about why not.

As one of many people who has contributed many hours to Mozilla, I don't
appreciate the decisions being handed down from on high and sans explanation.
Comment 66 Brian 'netdragon' Bober 2004-04-11 14:21:17 PDT
guanxi: That's probably something for the newsgroups. You can post the response
here. The best they could probably due is give a list of other bugs, along with
directions being taken. Those who fix the bugs get to choose the priority. What
I don't agree with is if there is a patch written, and they don't check it in or
even look at it because they don't consider it high enough priority, but
something like this I can understand. No patch exists, and therefore they can
choose which bugs to write patches for first.
Comment 67 ratman 2004-04-11 15:59:44 PDT
given the debate that seems to have emerged over this bug recently, it may be
helpful for someone to clarify whether a patch for this bug would even be
accepted.   if not, this bug should be marked invalid.

also, since the reasons in favor of patching this bug have been elucidated
clearly enough, it would be of benefit to establish the reason(s) why this bug
is considered to be a low (or lower) priority one, even if that reason is simply
a lack of interest amongst the mozilla developer community.  of course, perhaps
the lack of interest in opposing those supporting a patch may already signal that.



 
Comment 68 Damian Yerrick 2004-04-12 10:33:21 PDT
"Glyph sets that aren't in the Unicode standard ... in the meantime,
should use the Private Use Area. Note, though, that this has nothing
to do with this bug."

I am aware of a standardization of the Private Use Area for many
scripts that the Unicode Consortium has not yet added:
http://www.evertype.com/standards/csur/

But in such meantime, how would characters either
  1. in the Private Use Area, or
  2. in the Unicode standard but not in Microsoft's implementation,
get rendered on web pages without dynamic font support from the browser?
Comment 69 Hixie (not reading bugmail) 2004-04-12 10:54:13 PDT
> But in such meantime, how would characters [...] get rendered on web pages 
> without dynamic font support from the browser?

The same way they would for Bengali -- by have the user install a font locally.
Comment 70 Walter Baranger 2004-04-12 11:57:10 PDT
AND THEREIN LIES THE RUB: If we force users to download new fonts for possibly transient 
reasons (an Urdu speaker's brief visit to an Arabic page, perhaps), we shift the burden of 
cost -- buying the right font for the right platform -- to users who may be ill-equipped to 
afford it.  Regional, artistic and historical font variations are constant sources of 
frustration to both web designers and users; why kill off a useful tool like dynamic fonts?

Dynamic fonts allows the site owner the option of absorbing the cost of the fonts to be 
displayed; it allows the site designer to use just the right font and not just depend on a plain, 
generic font for all instances on a page.

Forcing web site owners who wish to show some design creativity to post Mac and PC 
versions of fonts that then must be downloaded and installed before someone can view a 
page seems regressive and pointless. It certainly makes web browsing a big pain. This 
especially hits third-world users who read lesser-used languages and who are otherwise 
stuck with a single generic Unicode font provided by Microsoft -- a font that might not be 
exactly right foe the task at hand.

Better to provide more tools than fewer tools, in this case at least.

Comment 71 Hixie (not reading bugmail) 2004-04-12 12:01:22 PDT
I'm confused; who are you arguing with? Everyone agrees that we should implement
this, don't they?
Comment 72 Dan Greening 2004-04-12 15:16:14 PDT
Walt (and perhaps others),

If NY Times offered to recommend the Mozilla browser on its site if it supported
font downloading, that would provide an incentive for someone to build it.

At present, there are a lot of people whining about the lack of dynamic font
support (me included), but no one so far has offered to either a) do it, or b)
pay for it.

I would imagine that font companies would have a financial incentive to support
downloadable fonts, because it would increase the number of purchased fonts, but
so far none have come forth.  Is anyone from Bitstream or another font company
on this list?  If not, and you know an influential person at one of these
companies, perhaps you, gentle reader, can forward this to see if there is
interest in either building or paying for dynamic font support.

We've all seen it's not enough to complain.  This bug is several years old.  We
need to find someone who gain money or fame from supporting this work, and ask
them to support it.
Comment 73 Thomas 'PointedEars' Lahn 2004-05-19 20:25:18 PDT
(In reply to comment #57)
> > Find me one Bengali site that doesn't use either dynamic fonts or pdf files
> 
> Sure, here's one:
> 
>
<http://www.stat.wisc.edu/~deepayan/Bengali/WebPage/Archive/Madhusudan/Chaturdashpadi/archive.bn.html>

Well, I see a lot of question marks in the Bengali version.  Am I supposed to
install (support for) Bengali fonts on my system (if there are some for it) to
see how Bengali looks like?  Unicode is merely an encoding.  You need proper
fonts to benefit from it.  So IMHO that there is Unicode is a null argument
against dynamic fonts.

BTW: I use .EOTs and .PFRs at my site with Valid CSS2 and would be very happy to
see this working in my favorite web browsers, Mozilla/5.0 Navigator and Firefox
as well.  Voted for this bug.


PointedEars
Comment 74 Daniel Wang 2004-06-26 18:14:43 PDT
*** Bug 208603 has been marked as a duplicate of this bug. ***
Comment 75 Mark E. Shoulson 2004-09-27 07:31:16 PDT
This is a little silly.  Everyone seems to agree that dynamic fonts would be a
Good Thing to have.  Even if they aren't, observed facts indicate that they are
in common use and people want them (including website designers who just want a
little better control over their typesetting).  They are a feature which argues
in favor of MSIE, and whether or not the people arguing for it are right or
wrong, lacking it puts Mozilla at a disadvantage.

This bug should probably be bumped in priority.  With Freetype and other
font-rendering engines improving, it should be possible to accomplish this.

(It would be a lot more convincing if I could say I was going to work on it, but
that remains to be seen)
Comment 76 Brian 'netdragon' Bober 2004-09-27 18:35:25 PDT
Priority is up to the developer working on it, which is none. Care to take it or
find someone?
Comment 77 Boris Zbarsky [:bz] 2004-09-29 09:16:10 PDT
*** Bug 261314 has been marked as a duplicate of this bug. ***
Comment 78 Chirag 2004-10-04 21:34:19 PDT
Mozilla does not support dynamic fonts
Comment 79 Ashutosh Tripathi 2004-10-18 01:27:47 PDT
Hi Folks,

This is the *only* issue due to which i
still need to fire up IE. I know of at least a couple
of people who are in the same boat as me.

Dynamic fonts worked just fine with Netscape4.x,
surely that code is lying around somewhere?

I noticed someone said "Find someone or pay for it",
well, i would be willing to donate something to a
paypal account if someone picks this up.
Or, if you are in Bay Area, California, call-me up
for a couple of cocktails followed by a nice 5 course dinner
costing, say 200 bucks, in a place of your choice? [If you
prefer cash, just come on by...]

Does it sound like i am desparate? Yes i am. I hate IE.
-ashu


Comment 80 Dan Greening 2004-10-18 08:19:43 PDT
I'd throw in another $200 for someone to add font downloading.
Comment 81 Kurtis McCathern 2004-10-18 09:40:36 PDT
I would give this a crack, but I haven't done any Mozilla related development
before.

Anybody got an idea where in the source to begin looking?
Comment 82 Paul Libbrecht 2004-10-18 15:27:48 PDT
One should browse around the bugs... the issue is simply that NS4 was linked to code of BitStream 
which was downloaded as part of NS4... so there's no real code to reuse down here.

So there's an amount of lobbying to be done, aside of plain code rehaul!

paul
Comment 83 Mark E. Shoulson 2004-10-18 15:45:41 PDT
Not necessarily.  Going the BitStream route probably isn't the best way to go
anyway: BitStream's PFRs were proprietary.  Mozilla should be able to use
TrueType/PostScript fonts dynamically, as well as some ultra-compressed PFR-like
format, if necessary.  PFRs themselves would be good, too, for compatibility,
but shouldn't be the only option.

> Additional Comment #82 From Paul Libbrecht  2004-10-18 15:27 PDT  

> One should browse around the bugs... the issue is simply that NS4 was 
> linked to code of BitStream which was downloaded as part of NS4... so 
> there's no real code to reuse down here.

> So there's an amount of lobbying to be done, aside of plain code rehaul!

> paul
Comment 84 Brian 'netdragon' Bober 2004-10-18 20:46:58 PDT
Kurtis: Even if a seasoned Mozilla developer isn't going to work on this, you
can probably get some pointers on where to look through newsgroups, etc. I also
suggest you look at other CSS2, and font patches in bugs and find where in the
source you can look for reference.
Comment 85 Kurtis McCathern 2004-10-19 09:36:51 PDT
Okay, just in poking around yesterday in the freshly-downloaded code, it is
pretty obvious that something like this needs to be done per platform, since all
the font managers obviously handle fonts differently - handing off the fonts to
the system for rendering according to the platform specific font supporting
mechanism.

I confess that, in general, I'm a really busy guy (aren't we all) and so people
probably shouldn't expect me to fix this problem. This will probably turn out to
be more of a learning exercise than anything else.  I'll keep looking at it, but
it will take some time to figure out the platform specificness.  I also know
this bug report isn't the place to discuss day to day workings of writing the
patch, so just assume for now that I'm not working on a patch, and then you'll
all be plesantly surprised if I come up with one.
Comment 86 Ashutosh Tripathi 2004-10-20 01:12:01 PDT
Best of luck Kurtis.

I really hope that some seasoned Mozilla developers
would help with some advice on the best way to proceed
and with some guidance to Kurtis on where to look.

I also hope that more people who have voted for this bug
would also vote with their wallets (even if it is
10-20 bucks, it all adds up).

And to re-iterate, my offer was neither in haste nor in jest,
it is a genunine offer which stands.

-ashu

Comment 87 Steven Lumos 2004-10-20 11:20:29 PDT
I'm willing to kick in something if it becomes official.  But I don't believe a
few hundred bucks is really the answer.  Some of those folks who work for major
companies who are waiting for dynamic fonts need to get those companies to make
a sizeable donation to the Mozilla Foundation and let them find a developer to
do the work.
Comment 88 Simon Montagu :smontagu 2004-11-28 23:39:29 PST
*** Bug 272200 has been marked as a duplicate of this bug. ***
Comment 89 Kurtis McCathern 2004-11-29 07:10:12 PST
Hey, due to personal events in my life, I'm gonna be unable to work on this bug
for the forseeable future (at least into next year) so if anybody else is
interested, they should pick this up.

When I dropped by the Mozilla dev channel, the guys weren't as helpful as they
could've been.  In fact, the guy who gave me the most information made it sound
like the change should be fairly easy for him, but he just didn't have time to
do it and when I was asking him questions kept responding just with "no, do it
this way" instead of explaining to me what was going on.

That said, it doesn't look impossible, but it does seem to involve interaction
between a couple of different parts of the Mozilla source, so a developer
knowledgeable about the Mozilla architecture is probably a better fit for this
than me.  If this is still open next year, I may look at it again.
Comment 90 Brian 'netdragon' Bober 2004-11-29 11:50:36 PST
> In fact, the guy who gave me the most information made it sound
> like the change should be fairly easy for him

Yeah, a lot of these bug fixes are easy conceptually for the strong hackers, but
still would be very time-consuming. The sad thing is that instead of documenting
what needs to be done for other people to make patches, they often don't give
any useful information in bugs and they sit unfixed when they could be fixed by
someone less familiar with the code if there were information given.

See bug 114760 -- Bugs not planning to be worked on need to be clarified for
other developers

I'm going to paste some of your comment in that bug.
Comment 91 Ashutosh Tripathi 2004-11-30 14:05:51 PST
Bummer. Maybe we have to find another way.
Anyone in the interest list a CS student who can perhaps pick this up
as part of a project or something?

Just throwing ideas around...
Comment 92 Jo Hermans 2004-12-12 05:35:00 PST
*** Bug 274246 has been marked as a duplicate of this bug. ***
Comment 93 Gérard Talbot 2004-12-16 21:19:17 PST
*** Bug 274287 has been marked as a duplicate of this bug. ***
Comment 94 Tuukka Tolvanen (sp3000) 2004-12-19 13:46:04 PST
*** Bug 275295 has been marked as a duplicate of this bug. ***
Comment 95 Olivier Cahagne 2005-02-21 06:02:16 PST
*** Bug 282991 has been marked as a duplicate of this bug. ***
Comment 96 Elmar Ludwig 2005-03-04 03:38:14 PST
*** Bug 284735 has been marked as a duplicate of this bug. ***
Comment 97 :Gavin Sharp [email: gavin@gavinsharp.com] 2005-03-31 21:51:50 PST
*** Bug 288577 has been marked as a duplicate of this bug. ***
Comment 98 Jo Hermans 2005-04-01 01:48:09 PST
*** Bug 288575 has been marked as a duplicate of this bug. ***
Comment 99 Simon Montagu :smontagu 2005-04-12 00:24:39 PDT
*** Bug 289879 has been marked as a duplicate of this bug. ***
Comment 100 Jo Hermans 2005-04-26 07:34:43 PDT
*** Bug 291928 has been marked as a duplicate of this bug. ***
Comment 101 :Gavin Sharp [email: gavin@gavinsharp.com] 2005-06-15 19:07:36 PDT
*** Bug 297864 has been marked as a duplicate of this bug. ***
Comment 102 Jo Hermans 2005-07-27 12:18:22 PDT
*** Bug 302365 has been marked as a duplicate of this bug. ***
Comment 103 Jaime Mitchell (use bugmail@jaimem.org.uk for email) 2005-08-17 10:04:11 PDT
*** Bug 304984 has been marked as a duplicate of this bug. ***
Comment 104 Ognyan Kulev 2005-08-17 10:31:58 PDT
In http://www.svgopen.org/2005/papers/MozillaSVG/#S6.1 , it's stated that Full
SVG 1.1, including SVG defined fonts, is planned for Mozilla Firefox 2.0.  I
wonder if this somehow means that we'll have WebFonts as side affect, or at
least will be one step further for implementing CSS3 WebFonts.
Comment 105 :Gavin Sharp [email: gavin@gavinsharp.com] 2005-10-19 08:16:37 PDT
*** Bug 312981 has been marked as a duplicate of this bug. ***
Comment 106 Simon Montagu :smontagu 2005-11-10 02:52:14 PST
*** Bug 315628 has been marked as a duplicate of this bug. ***
Comment 107 :Gavin Sharp [email: gavin@gavinsharp.com] 2005-11-21 09:01:50 PST
*** Bug 315629 has been marked as a duplicate of this bug. ***
Comment 108 Uri Bernstein (Google) 2005-11-23 05:03:10 PST
*** Bug 317537 has been marked as a duplicate of this bug. ***
Comment 109 Kim Scarborough 2005-11-23 09:56:44 PST
I know I've beaten this point to death, but... I wish that the bugs being filed about Indian web sites with incorrect character encoding that depend on font embedding would not get marked as duplicates of this bug. That's not the point of font embedding, and marking them as duplicates against this gives that false impression. This is a *design* enhancement request.
Comment 110 Uri Bernstein (Google) 2005-11-23 10:00:18 PST
(In reply to comment #109)
> I know I've beaten this point to death, but... I wish that the bugs being filed
> about Indian web sites with incorrect character encoding that depend on font
> embedding would not get marked as duplicates of this bug. That's not the point
> of font embedding, and marking them as duplicates against this gives that false
> impression. This is a *design* enhancement request.

I won't do it again.
Comment 111 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2005-11-23 13:15:10 PST
It would be good if they're duplicates of something, though, since it may be useful to know how many such bugs we're getting.
Comment 112 Robert Orso 2005-11-23 23:10:59 PST
With 5+ years open, this must be the oldest unresolved bug in the database. Firefox 1.5 is targeting CSS 3.0 and still unable to render dynamic fonts?

Would some authority please mark this as "will never happen as nobody is interested to solve it, despite it is part of CSS2" so we no longer wait for it. Then we can tell our customers to use IExx and end this discussions for all time.
Comment 113 Jacek Piskozub 2005-11-23 23:42:34 PST
(In reply to comment #112)
> With 5+ years open, this must be the oldest unresolved bug in the database.

Nope. Bug 9942 wins hands down (actually by 14 months).

Have a good Thanksgiving!
Comment 114 Jacek Piskozub 2005-11-23 23:51:26 PST
Actually I've checked that the oldest surviving beast on the database is bug 350 opened on 1998-05-14 01:20 PST. So do not bother us with such freshies as this little problem, young man.

Sorry for the spam.
Comment 115 Ashish Bhargave 2005-11-24 12:57:14 PST
I have to repeatedly swith to IE because of this issue. Many non-english websites use dynamic fonts, and for that reason, that huge community can never use Firefox. Many people, like my wife, will never switch to Firefox because of this issue.
Comment 116 Sandhitsu Das 2005-11-24 13:18:13 PST
(In reply to comment #115)
> I have to repeatedly swith to IE because of this issue. Many non-english
> websites use dynamic fonts, and for that reason, that huge community can never
> use Firefox. Many people, like my wife, will never switch to Firefox because of
> this issue.
> 

That's very very true. It's been a big annoynace for me for years. Either people don't switch or - like me - can't read some newspapers I love to read because I don't (want to) work on Windows. And somehow I find it surprising why this doesn't move up in priority given there is a lot of potential to get more people to use mozilla-based browsers just by implementing this. I know at least 10 people in my own immediate friend's circle, and my wife - who would do that.
Comment 117 vnagarjuna 2005-12-09 11:12:34 PST
Try using the FF/TB extension Padma (https://addons.mozilla.org/extensions/moreinfo.php?application=firefox&id=873) as a partial solution to this problem.
Comment 118 Sandhitsu Das 2005-12-09 11:31:11 PST
Is there a similar add-on for Bengali ?

(In reply to comment #117)
> Try using the FF/TB extension Padma
> (https://addons.mozilla.org/extensions/moreinfo.php?application=firefox&id=873)
> as a partial solution to this problem.
> 
Comment 119 Kevin Newman 2005-12-09 11:36:32 PST
Do these extensions include code that can be used to add support for dynamic fonts, or do they just detect that a dynamic font has been used, and adjust the characters from the page to the appropriate range in already installed Unicode fonts (which means they do not actually use any dynamic fonts)?
Comment 120 Jo Hermans 2006-03-12 15:07:08 PST
*** Bug 330250 has been marked as a duplicate of this bug. ***
Comment 121 Phil Ringnalda (:philor) 2006-08-26 14:33:57 PDT
*** Bug 344645 has been marked as a duplicate of this bug. ***
Comment 122 Jo Hermans 2006-11-16 09:28:10 PST
*** Bug 360910 has been marked as a duplicate of this bug. ***
Comment 123 Rudd-O 2006-11-16 13:51:52 PST
Owm... OK

1. This is not an internationalization bug.  All you bengalis please demand that Web pages are written correctly.  It's your problem.
2. This should not be very hard to implement.  We have Pango rendering now.  See http://developer.gnome.org/doc/API/2.0/pango/index.html and start from there.
Comment 124 Kevin Newman 2006-11-16 14:44:18 PST
3. This is also a practical problem. Right now there are n number of sites that rely on this feature, that don't currently work in Gecko based browsers. To say they should write to the standards or fix their own sites is a good suggestion, but it doesn't solve the problem as much as it just points to the cause, and it's easier said than done.

4. This feature has more use than just to get those sites to work in Gecko based browser. With all the talk these days about RIAs it'd be nice to finally get first rate font support in html (well, to re-get it, since it existed in the 4.0 days). Making dozens of header graphics, or using Flash/JavaScript based work-a-rounds is really getting old. Gecko has had support for JavaScript, DOM, HTML, SVG, XML, XHTML, CSS, various image formats etc., all so you can have a richer web based experience, but it still doesn't support embedded fonts, after all these years.

I understand that the people who could implement this feature are busy with other, probably more important things, and I'm willing to wait for someone to fix this, since I don't have the knowledge or time to do it myself. So please don't get me wrong. I do think it's time to move this up on the list of priorities though. (Just my two cents)
Comment 125 Paul Libbrecht 2006-11-17 00:58:44 PST
I wish to add that font availability is another weak point that we all experience with mathematical documents on the web: no author can be sure that a given character will be rendered. I would expect downloadable fonts to solve most of these problems in a way that is still clean (for the html code) and accessible, as opposed to any server-side-rendering.

And as far as I know there is no way in javascript or CSS to know about the availability of a glyph in any font (you can select based on unicode ranges availability in CSS but that's way too coarse, e.g., no font implements the full math unicode range!).
Comment 126 Robert Orso 2006-11-17 01:56:45 PST
May I remind the developers on chapter 15 of the CSS2 definition (from 1998!) which clearly defines how fonts are to be handled, with a long paragraph on font sources and file formats.

http://www.w3.org/TR/REC-CSS2/fonts.html#referencing

My I remind further that the SVG specifications do make use of "loadable fonts" too:

http://www.w3.org/TR/SVG/fonts.html

Mozilla is proud to comply to both of these specifications, as long nobody talks about the font issue. It's some kind of "family secret", hidden deep in the dungeons. A nasty daemon that raises it's head after each and every new release and that is kept quiet by stubborn ignoring.

It looks as if the Mozilla development team has order to keep their fingers off any font issues and to focus the work on cosmetic enhancements instead of implementing missing parts of the specifications.

Now that we have FF 2.0, there is again some moaning about this, that will eventually die out as usual after a few weeks.

The developers do magic every day in different parts of the program. All specifications are published and OpenType is free to use, so copyright is not a problem here. I cannot believe it's out of their capability to make a public accessible font file available to the operating system.

Luckily, since M$ has just released it's new IE7, which is a vast improvement over 6.0 and which got almost every CSS problem fixed, there is a true alternative now. At least for all of the Windows users.
Comment 127 anu 2006-11-17 10:00:29 PST
<snip>We have Pango rendering now. <snip> 


Now that's called passing the buck. Pango (as of today) can't even render *unicode Indic fonts* decently. Refer: https://bugzilla.mozilla.org/show_bug.cgi?id=356049


Well, as the saying goes, if you can't be part of a solution to a problem, atleast  you can be at your best in making it more complex. 
Comment 128 Rudd-O 2006-11-17 14:50:30 PST
What I meant about having Pango now is that Pango can interpret font data, and together with fontconfig or the "other OS's" native font technology it's now feasible to download a TTF (and, in Linux, Adobe Type 1) font referred to by  @font-face{ ... }
Comment 129 Phil Ringnalda (:philor) 2006-11-22 21:13:27 PST
*** Bug 361622 has been marked as a duplicate of this bug. ***
Comment 130 Phil Ringnalda (:philor) 2006-11-22 21:43:44 PST
*** Bug 361622 has been marked as a duplicate of this bug. ***
Comment 131 Phil Ringnalda (:philor) 2007-02-11 01:44:15 PST
*** Bug 370039 has been marked as a duplicate of this bug. ***
Comment 132 Gérard Talbot 2007-04-13 13:36:13 PDT
*** Bug 213213 has been marked as a duplicate of this bug. ***
Comment 133 Gérard Talbot 2007-04-14 13:09:06 PDT
The provided URL, http://www.malayalamanorama.com , is very difficult, if not, impossible to understand from a web standards and from a web author point of view. First, it uses no doctype declaration, has over 460 validation markup errors (and that is in transitional DTD, not strict DTD), abuses javascript, flash, blinking stuff, advertisements, overconstrained tables, over-excessively defined markup code, over-excessively constrained markup code, over-declared markup code, tons of <br>, &nbsp;, spacer.gif, etc, etc, etc... 

The webpage is declared to be written in English - not in Malayalam -
line 45: <html lang="en"> 
line 66: <META content="en-gb" name="language">
it's to be served as iso-latin1 on top of that
line 69: <META http-equiv="content-type" content="text/html; charset=ISO-8859-1" >
and to use the Manorama font and no other proposed font. The thing with Manorama font is that it is not an Unicode font: all Malayalam glyphs are occupying latin-basic positions and not their respective assigned positions in Unicode. So, this is a major serious flaw with the design of the webpage. 

You see, I had myself already a true Unicode font for Malayalam language (Kartika.ttf) and it was installed many years ago. The web author of that site is making many mistakes, serious ones.
For Western languages (languages covered by iso-8859-1), I only choose fonts that are capable of rendering western languages, and definitely not Malayalam language. The web author goes against such logic; the web author goes against very reasonable, coherent and rational assumptions for both the browser users and for browser vendors/manufacturers.
If the web author had defined in this manner 

<html lang="ml"> 
<META content="ml" name="language">
<META http-equiv="content-type" content="text/html; charset=utf-8">

his webpage, then I would have been able to see the correct Malayalam glyphs even if he had also declared
body {font-family: serif;}
because, in my settings, I have a default serif font for utf-8.

The browser detect and forking code at
http://static.manoramaonline.com/portal/manoramafont/cpy_bvfont.js
is also extremely questionable, poor and bound to be wrong most of the time. Very few versions of Netscape support pfr. Not all non-Netscape browsers support .eot, only MSIE5+.

-----------------

The purpose of dynamic fonts is not to support international charsets and should not be used to support international charsets. 
"supporting international character sets via font embedding is an 
awful practice that needs to be stopped."
"This is not an internationalization bug." 
Agreed.

Removing intl keyword
Comment 134 Gérard Talbot 2007-04-14 15:24:40 PDT
(In reply to comment #57)
> > Find me one Bengali site that doesn't use either dynamic fonts or pdf files
> 
> Sure, here's one:
> 
> <http://www.stat.wisc.edu/~deepayan/Bengali/WebPage/Archive/Madhusudan/Chaturdashpadi/archive.bn.html>

I went to that site. The webpage is encoded as utf-8 but the webserver serves it as iso-8859-1: this mismatch causes problems on the users application browser. 

Web sniffer to access the HTTP response headers will indicate that the server reads the document as iso-8859-1 and not as utf-8 and so the character encoding mismatch is easy to see:
http://web-sniffer.net/?url=http%3A%2F%2Fwww.stat.wisc.edu%2F%7Edeepayan%2FBengali%2FWebPage%2FArchive%2FMadhusudan%2FChaturdashpadi%2Farchive.bn.html&submit=Submit&http=1.1&gzip=yes&type=GET

The character encoding mismatch is reported by the W3C validator:
http://validator.w3.org/check?uri=http://www.stat.wisc.edu/~deepayan/Bengali/WebPage/Archive/Madhusudan/Chaturdashpadi/archive.bn.html
(99 errors with transitional DTD)

This character encoding issue (the web server is MISconfigured) is rather easy to fix and is covered by several documents.
Comment 135 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2007-04-14 15:51:44 PDT
(In reply to comment #133)
> The provided URL, http://www.malayalamanorama.com , is very difficult, if not,
> impossible to understand from a web standards and from a web author point of
> view. First, it uses no doctype declaration, has over 460 validation markup
> errors (and that is in transitional DTD, not strict DTD), abuses javascript,
> flash, blinking stuff, advertisements, overconstrained tables, over-excessively
> defined markup code, over-excessively constrained markup code, over-declared
> markup code, tons of <br>, &nbsp;, spacer.gif, etc, etc, etc... 

That doesn't have anything to do with this bug report.  The rest of the comment is relevant but is repeating what was already said in comment 38.

There is consensus that using dynamic fonts is the wrong way to build international language Web sites -- using the correct Unicode characters is far superior.  But the facts remain that (1) many sites do use dynamic fonts for this purpose, and (2) that there are other valid uses of dynamic fonts desired by authors.

Either way, at this point this bug report has so many comments that anything written here is unlikely to influence any eventual implementation of dynamic fonts since whoever does the implementation is unlikely to find the comment.  Things that require *discussion* should generally take place in newsgroups / mailing lists, not bug reports.

Developers have discussed implementing dynamic fonts a number of times recently, but not in this bug.  The problem is that there are basically two approaches, both of which are quite difficult:
 (1) getting the system to select and render the font, which requires inserting a font into the system's font selection mechanism in a way that applies only to one page and not to any others
 (2) selecting and rendering the font ourselves, which means that we have to stop using the system's font selection mechanism and do it ourselves in order to interleave system fonts with dynamically provided fonts.

Both of these require significant amounts of code.
Comment 136 Paul Libbrecht 2007-04-17 01:34:48 PDT
I do not agree that "using dynamic fonts is wrong for internationalization purposes". What's wrong is only "using wrong encodings" as seems to be described in the usage of the web-page above.

This does not remove the need for dynamic fonts for me, for example, to display most fancy characters, even properly encoded: my machine can display some chinese but I am convinced it is missing an amount of other glyphs.

And I do know that it is missing most glyphs of the math unicode tables and most probably of the symbol ones... both purposes justify dynamic fonts, I believe, just as a better font-predictability. Remember... at the time, people we putting pictures instead!
Comment 137 Ognyan Kulev 2007-04-19 01:57:36 PDT
I would like to share my findings about how dynamic fonts can be implemented in Gecko. All 3 platforms have ability to temporarily add TrueType or OpenType font that can be used only in the calling application and is not installed system-wide:

Windows: AddFontResourceEx <http://msdn2.microsoft.com/en-us/library/ms533937.aspx>

Linux: FcConfigAppFontAddFile <http://www.fontconfig.org/fontconfig-devel/r1988.html>

MacOSX: ATSFontActivateFromFileSpecification <http://developer.apple.com/documentation/Carbon/Reference/ATS/Reference/reference.html#//apple_ref/c/func/ATSFontActivateFromFileSpecification>

Gecko must handle cases when different pages use different downloaded fonts that have same names. I think that downloaded font files should always be changed by Gecko so that names are unique (e.g. like "Gecko-4F2A5BBC") and CSS font names that use this downloaded font must internally be renamed to the unique name. This will add code for changing font name in font file but I think it won't be much code because it's for such specific purpose.

I guess part of such implementation will be in cairo project.

I would like to see comments from more knowledgable people if the above may work or there are flaws about it.
Comment 138 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2007-04-19 10:33:10 PDT
The main issues I can think of at first glance are:
 * those APIs may not be designed for untrusted fonts and thus may have security bugs when handling malformed font files

 * the set of font formats that we want to support should be the same across platforms (though we could handle that by restricting what we pass to those APIs to fonts that we've checked ourselves are cross-platform formats)

The renaming hack seems like it could work, although it's really a workaround for the lack of font selection contexts to which fonts could be added.  (However, would that really work?  Is the name always an argument to the function rather than something contained *inside* the font?)
Comment 139 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2007-04-19 10:37:12 PDT
The other issue with the renaming hack is that (even if it doesn't affect other apps), there are cases where *we* search through all remaining fonts to find a font with a particular character; we don't want to use fonts provided by other Web pages (since the behavior is then nondeterministic, and the fonts may be hacks that provide incorrect glyphs).
Comment 140 Kevin Newman 2007-04-19 11:32:35 PDT
So basically there are (at least) 4 different tasks to get this working:

1. Do platform work to utilize each of these three different APIs to get the fonts to load for Mozilla app only (not system wide).

2. Figure out how to validate Fonts to avoid possible malformed font attacks (if the system methods don't do that already). Could FreeType be used to parse and validate font formats (even if it's not used to actually draw the fonts)?

3. Find every function that deals with system fonts and font lists, and make them ignore the temporarily renamed page specific fonts. If there is an interface for that (I'm not familiar with the code base), that'd be great, cause you'd just have to modify that. Otherwise, maybe it's a good idea to build that interface and make the rest of the code base use that.

4. Make sure we only allow cross platform fonts - .ttf (both TrueType and OpenType) seem to be the most compatible, maybe .otf (CFF PostScript glyphs in OpenType package) are also compatible (though in .NET at least, they were not compatible to use in private font lists until v3.0 - I don't know if that was a .NET or an underlying platform problem).

I'd also add:

5. Before any of the private font installation stuff starts, Mozilla should check the embed bit in the fonts, to see if embedding is allowed, and abort if not.

6. Could FreeType be used to convert non-system font formats like .eot or adobe .cff (embedded by Illustrator in some SVG fonts) to a compatible font (like .otf) to be installed for Mozilla as described above (it might be worth it to check with the font forge people on that)?

7. Would any of this help with SVG glyphs, or could a ground up SVG glyphs implementation be used instead of this whole idea? In this model, you'd have to use a tool (like Adobe Illustrator) to convert the fonts to SVG glyphs, and embed that instead of the actual font file(s).
Comment 141 Damian Yerrick 2007-05-05 15:26:29 PDT
From comment 133:

"The purpose of dynamic fonts is not to support international charsets and
should not be used to support international charsets."

Then what technology should be used to support those international charsets for which the operating system does not supply a font? And what technology should be used to support those international charsets that were not encoded in Unicode at the time the operating system was released? GIFs?

Which mailing list or newsgroup would be most appropriate for questions like this?


From comment 140:

"Could FreeType be used to parse and validate font formats (even if it's not used to actually draw the fonts)?"

Maybe not.  TrueType fonts may contain hint programs that modify glyphs before they are rasterized.  Microsoft and Apple implementations use these hint programs.  FreeType's default configuration ignores hint programs and will do so for several more years until Apple's patents on hint programs run out.
Comment 142 Ognyan Kulev 2007-05-16 05:38:54 PDT
Have anyone considered drawing WebFonts with cairo instead of using system font API? cairo 1.6 has user font API in their ROADMAP <http://gitweb.freedesktop.org/?p=cairo.git;a=blob;h=2eb28f48088c78ddb8dc8e9498f318dc4a4a1937;hb=9da86e4a386505288c3a933f30583abf7706c950;f=ROADMAP#l64> and it seems it's relevant to SVG fonts <http://weblogs.mozillazine.org/tor/archives/2007/04/smil_animation_and_svg_fonts.html>.  But I'm not sure if it's better path than using system font API - @font-face is much more important for non-latin languages and many of them (Indic, Arabic, ...) use features beyond simple character code -> glyph mapping. I'm not sure if SVG font ligatures will be enough.

Is this reasoning (that not using system font API limits WebFonts usefulness too much) correct?
Comment 143 Jo Hermans 2007-09-14 14:13:03 PDT
*** Bug 396195 has been marked as a duplicate of this bug. ***
Comment 144 Tiago 2007-09-14 20:37:28 PDT
This Bug has a7 years old, isn't it time to fix it, my bug report (396195) was marked has duplicate because i worked the way arround it with the letters in IE with .eot and in other browsers with flash but with flash is very complicated and unrealyable cause i loose the button effect on Browser and the links are lost has well. It's been marked to be solved in the future and the future is now.
Please feedback has soon has possible!
Comment 145 Phil Ringnalda (:philor) 2007-09-14 21:48:38 PDT
*** Bug 396195 has been marked as a duplicate of this bug. ***
Comment 146 Christopher J. Fynn 2008-03-13 20:24:22 PDT
IMO The best way to fix this would be to add support for CSS 3 @fontface 
see bug: 70132

Comment 147 David E. Ross 2008-07-05 10:20:10 PDT
I must agree.  Mozilla products are promoted as compliant with W3C specifications.  Thus, the implementation of dynamic fonts should comply with W3C's "Web Fonts" module of CSS3.  

Before implementing @font-face, however, it would be best if the "Web Fonts" specification were brought closer to a final version; it's currently a working draft that hasn't been updated in six years.  This is a W3C issue beyond the authority of Mozilla, but the Mozilla Foundation is a W3C member and should be able to push for progress on this specification.  
Comment 148 John Daggett (:jtd) 2008-07-05 18:23:32 PDT
(In reply to comment #147)

> Before implementing @font-face, however, it would be best if the "Web Fonts"
> specification were brought closer to a final version; it's currently a working
> draft that hasn't been updated in six years.  This is a W3C issue beyond the
> authority of Mozilla, but the Mozilla Foundation is a W3C member and should be
> able to push for progress on this specification.  

Work on a new draft of the CSS3 Fonts spec, one that simplifies the definition of @font-face and is closer to what Safari, Prince, Opera and Mozilla implement or plan to implement, is already underway:

  http://dev.w3.org/csswg/css3-fonts

Once the rewriting has been completed and the CSS WG has a chance to discuss issues related to this, I'll switch over the CSS3 Fonts and CSS3 Web Fonts URL's to point to the new working draft.  I'm sure there will be general discussions of this on the public www-style mailing list.

The @font-face implementation Gecko is tracked via bug 70132 and its dependent bugs.

Comment 149 Neil Harris 2008-07-10 07:21:47 PDT
I've added a new bug, bug 444571, relating to the distribution of what for a better term might be called "Free Software core fonts". Whilst only tangentially related to this bug, the proposal addresses some of the same issues discussed here, such as support for Indic languages.
Comment 150 Kevin Brosnan 2009-02-04 04:24:37 PST
*** Bug 476832 has been marked as a duplicate of this bug. ***
Comment 151 Yuh-Ruey Chen 2009-09-13 03:49:10 PDT
*** Bug 226810 has been marked as a duplicate of this bug. ***
Comment 152 Joseph 2010-03-24 19:03:43 PDT
@font-face {
 font-family: "manorama";
 src: url("http://www.manoramaonline.com/mmfont/Manorama.ttf");
}

works just fine for me on the original page submitted for an example...  I don't see a problem with the original bug in current Firefox
Comment 153 Robert Orso 2010-03-24 23:24:37 PDT
This bug has finally been fixed with Firefox 3.6 (Gecko 1.9.2) 
I opt that it may be closed.
Comment 154 John Daggett (:jtd) 2010-03-24 23:37:45 PDT
Wow, neat, forgot this was lurking.  @font-face support shipped with 3.5, closing this.

Note You need to log in before you can comment on or make changes to this bug.